/*
    Project: TCTEMP
    Version: V1.11
    File   : setup.c

    Copyright (c) 2006-2008 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.3 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#define _WIN32_WINNT 0x0500
#include <windows.h>
#include <shlobj.h>
#include <tchar.h>

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
  LPSTR lpCmdLine, int nCmdShow)
{
    LPWSTR           *wszArgList;
    int              nArgs;
    OSVERSIONINFO    osvi;
    WCHAR            wszParameters[MAX_PATH + 20];
    SHELLEXECUTEINFO sei;

    UNREFERENCED_PARAMETER(hInstance);
    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);
    UNREFERENCED_PARAMETER(nCmdShow);

    *wszParameters = L'\0';
    wszArgList = CommandLineToArgvW(GetCommandLineW(), &nArgs);
    if (wszArgList) {
        if (nArgs == 2) {
            if (wcslen(wszArgList[1]) < MAX_PATH) {
                wcscpy(wszParameters, L"/C \"");
                wcscat(wszParameters, wszArgList[1]);
                wcscat(wszParameters, L"\" runasadmin");
            }
        }
        LocalFree(wszArgList);
    }

    if (*wszParameters == L'\0' || !IsUserAnAdmin()) {
        return 0;
    }

    osvi.dwOSVersionInfoSize = sizeof(osvi);
    if (!GetVersionEx(&osvi) || osvi.dwPlatformId != VER_PLATFORM_WIN32_NT ||
      osvi.dwMajorVersion < 6) {
        return 0;
    }

    memset(&sei, '\0', sizeof(sei));
    sei.cbSize = sizeof(sei);
    sei.lpVerb = L"runas";
    sei.lpFile = L"cmd.exe";
    sei.lpParameters = wszParameters;
    sei.nShow = SW_SHOWNORMAL;
    ShellExecuteEx(&sei);

    return 1;
}
